<?php 

defined ('ABSPATH') or die ('No scripts kiddies please!');
if (! Defined ('ABSPATH')) exit; // Sair se acessado diretamente

// Conectando a função de paginaPlugin com o action hook
add_action('admin_menu', 'easy_color_pluginPage');

// Conectando a função de colocar script no footer com o actionhook - INUTEIS NO EASY COLOR - TIRA DEPOIS 
// add_action('wp_footer', 'ccm_myScript');
// add_action('wp_head', 'ccm_myCSS');

// Define página do plugin
function easy_color_pluginPage(){

    add_menu_page(
        'Easy Color',
        'Easy Color',
        'manage_options',
        'easy-color.php',
        'easy_color_checkPluginPage',
		plugin_dir_url(__FILE__) . '/imgs/icon.png',
		20
    );
}

// Verificando Página do Plugin
function easy_color_checkPluginPage(){
    require_once "easy-color.php";
}

function easy_color_pathOfIncludes(){
	//return '/wp-content/plugins/easy/includes/';
	return plugin_dir_url( __FILE__ ); 
}


// Criar tabelas de variaveis do CSS - MUDAR ISSO PARA CRIAR TABELA
function easy_color_createTables(){
	
	easy_color_createATableToSelectors('easyColorSelectorsCSSToBG_link');
	easy_color_createATableToSelectors('easyColorSelectorsCSSToFont_link');
	easy_color_createATableToSelectors('easyColorSelectorsCSSToBorder_link');
	
	easy_color_createATableToSelectors('easyColorSelectorsCSSToBG_main');
	easy_color_createATableToSelectors('easyColorSelectorsCSSToFont_main');
	easy_color_createATableToSelectors('easyColorSelectorsCSSToBorder_main');
	
	easy_color_createATableToSelectors('easyColorSelectorsCSSToBG_secondary');
	easy_color_createATableToSelectors('easyColorSelectorsCSSToFont_secondary');
	easy_color_createATableToSelectors('easyColorSelectorsCSSToBorder_secondary');
	
}

function easy_color_createATableToSelectors($tableName){
	
	global $wpdb; // importante
	$table_name = $wpdb->prefix . $tableName; // nome da tabela
	$charset_collate = $wpdb->get_charset_collate(); 
	
	$sql = "CREATE TABLE $table_name (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		selector tinytext NOT NULL,
		PRIMARY KEY  (id)
	) $charset_collate;"; // Cria tabela
	
	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' ); // Importa o arquivo de atualização de tabela
	dbDelta( $sql ); // Coloca tabela
}


// Inserir classes CSS no BD
function easy_color_insertClassOnTable() {
	// LINK
	$newSelectorToBG_link = sanitize_text_field($_POST["newSelectorBGColor_link"]);
	$newSelectorToFont_link = sanitize_text_field($_POST["newSelectorToFontColor_link"]);
	$newSelectorToBorder_link = sanitize_text_field($_POST["newSelectorToBorderColor_link"]);
	
	if (!$newSelectorToBG_link == ''){  easy_color_insertDataOnBD('easyColorSelectorsCSSToBG_link', 'selector', $newSelectorToBG_link); }
	if (!$newSelectorToFont_link == ''){ easy_color_insertDataOnBD('easyColorSelectorsCSSToFont_link', 'selector', $newSelectorToFont_link); }
	if (!$newSelectorToBorder_link == ''){ easy_color_insertDataOnBD('easyColorSelectorsCSSToBorder_link', 'selector', $newSelectorToBorder_link); }
	
	// MAIN
	$newSelectorToBG_main = sanitize_text_field($_POST["newSelectorBGColor_main"]);
	$newSelectorToFont_main = sanitize_text_field($_POST["newSelectorToFontColor_main"]);
	$newSelectorToBorder_main = sanitize_text_field($_POST["newSelectorToBorderColor_main"]);
	
	if (!$newSelectorToBG_main == ''){  easy_color_insertDataOnBD('easyColorSelectorsCSSToBG_main', 'selector', $newSelectorToBG_main); }
	if (!$newSelectorToFont_main == ''){ easy_color_insertDataOnBD('easyColorSelectorsCSSToFont_main', 'selector', $newSelectorToFont_main); }
	if (!$newSelectorToBorder_main == ''){ easy_color_insertDataOnBD('easyColorSelectorsCSSToBorder_main', 'selector', $newSelectorToBorder_main); }
	
	// SECONDARY
	$newSelectorToBG_secondary = sanitize_text_field($_POST["newSelectorBGColor_secondary"]);
	$newSelectorToFont_secondary = sanitize_text_field($_POST["newSelectorToFontColor_secondary"]);
	$newSelectorToBorder_secondary = sanitize_text_field($_POST["newSelectorToBorderColor_secondary"]);
	
	if (!$newSelectorToBG_secondary == ''){  easy_color_insertDataOnBD('easyColorSelectorsCSSToBG_secondary', 'selector', $newSelectorToBG_secondary); }
	if (!$newSelectorToFont_secondary == ''){ easy_color_insertDataOnBD('easyColorSelectorsCSSToFont_secondary', 'selector', $newSelectorToFont_secondary); }
	if (!$newSelectorToBorder_secondary == ''){ easy_color_insertDataOnBD('easyColorSelectorsCSSToBorder_secondary', 'selector', $newSelectorToBorder_secondary); }
	
	
}

// Apagar classes CSS no BD
function easy_color_removeClassOnTable() {
	//echo "APAGANDO...";
	
	// LINK
	$selectorToRemoveBG_link = sanitize_text_field($_POST["newSelectorBGColor_link"]);
	$selectorToRemoveFont_link = sanitize_text_field($_POST["newSelectorToFontColor_link"]);
	$selectorToRemoveBorder_link = sanitize_text_field($_POST["newSelectorToBorderColor_link"]);
	
	if (!$selectorToRemoveBG_link == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToBG_link', 'selector', $selectorToRemoveBG_link); }
	if (!$selectorToRemoveFont_link == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToFont_link', 'selector', $selectorToRemoveFont_link); }
	if (!$selectorToRemoveBorder_link == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToBorder_link', 'selector', $selectorToRemoveBorder_link); }
	
	// MAIN
	$selectorToRemoveBG_main = sanitize_text_field($_POST["newSelectorBGColor_main"]);
	$selectorToRemoveFont_main = sanitize_text_field($_POST["newSelectorToFontColor_main"]);
	$selectorToRemoveBorder_main = sanitize_text_field($_POST["newSelectorToBorderColor_main"]);

	if (!$selectorToRemoveBG_main == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToBG_main', 'selector', $selectorToRemoveBG_main); }
	if (!$selectorToRemoveFont_main == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToFont_main', 'selector', $selectorToRemoveFont_main); }
	if (!$selectorToRemoveBorder_main == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToBorder_main', 'selector', $selectorToRemoveBorder_main); }
	
	// SECONDARY
	$selectorToRemoveBG_secondary = sanitize_text_field($_POST["newSelectorBGColor_secondary"]);
	$selectorToRemoveFont_secondary = sanitize_text_field($_POST["newSelectorToFontColor_secondary"]);
	$selectorToRemoveBorder_secondary = sanitize_text_field($_POST["newSelectorToBorderColor_secondary"]);
	
	if (!$selectorToRemoveBG_secondary == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToBG_secondary', 'selector', $selectorToRemoveBG_secondary); }
	if (!$selectorToRemoveFont_secondary == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToFont_secondary', 'selector', $selectorToRemoveFont_secondary); }
	if (!$selectorToRemoveBorder_secondary == ''){ easy_color_removeDataOnBD('easyColorSelectorsCSSToBorder_secondary', 'selector', $selectorToRemoveBorder_secondary); }
	
	

}

function easy_color_insertDataOnBD($tableName, $column, $data){
	global $wpdb;
	$table_name = $wpdb->prefix . $tableName;
	$wpdb->insert( $table_name, array($column => $data));
}

function easy_color_removeDataOnBD($tableName, $column, $data){
	global $wpdb;
	$table_name = $wpdb->prefix . $tableName;
	$wpdb->delete( $table_name, array($column => $data));
}


// pega o valor de uma variável no banco de dados
function easy_color_getClassesOnBd($tableName){
	global $wpdb;
	$color;
	
	$string = "";
	
	$classes = $wpdb->get_results( "SELECT * FROM " . $wpdb->prefix . $tableName ."");
	$i = 0;
	foreach($classes as $class){
		if($i + 1 < count($classes)){
			$string .= $class->selector .", ";
		}else{
			$string .= $class->selector ." ";
		}
		$i += 1;
	}
	//echo count($classes);
	return $string;
}

function getColors($whichOne){
	$theColor = '';
	
	$color_scheme = flash_get_color_scheme();
	$default_color = $color_scheme[1];
	$link_color = get_theme_mod( 'link_color', $default_color );
	
	$default_color   = $color_scheme[2];
	$main_text_color = get_theme_mod( 'main_text_color', $default_color );
	
	$default_color   = $color_scheme[3];
	$secondary_text_color = get_theme_mod( 'secondary_text_color', $default_color );

	// Don't do anything if the current color is the default.
	if ( $link_color === $default_color ) {
		return;
	}
	
	switch ($whichOne){
		case "link_color":
			$theColor = $link_color;
			break;
		case "main_text_color":
			$theColor = $main_text_color;
			break;
		case "secondary_text_color":
			$theColor = $secondary_text_color;
			break;
	}

	
	
	return $theColor;
}


/**
 * Enqueues front-end CSS for the link color.
 *
 * @since Flash 1.0
 *
 * @see wp_add_inline_style()
 * 
 * COM ISSO EU CONSEGUI USAR A FUNÇÃO CORRETA
 */
function easy_color_flash_link_color_css_MINHA() {
	$color_scheme    = flash_get_color_scheme();
	$default_color   = $color_scheme[1];
	$link_color = get_theme_mod( 'link_color', $default_color );

	// Don't do anything if the current color is the default.
	if ( $link_color === $default_color ) {
		return;
	}

	// Convert link color to rgba.
	$link_color_rgb = flash_hex2rgb( $link_color );

	// Generate Darker Color
	$link_color_dark = flash_darkcolor( $link_color, -20 );

	// If we get this far, we have a custom color scheme.
	$border_color = vsprintf( 'rgba( %1$s, %2$s, %3$s, 0.8)', $link_color_rgb );

	$css = '
	/* Custom Color Scheme - Easy Color */
	
	/* BG COLOR */
	'. easy_color_getClassesOnBd('easyColorSelectorsCSSToBG_link') .'{
		background-color: %1$s;
	}
	
	/* FONT COLOR */
	'. easy_color_getClassesOnBd('easyColorSelectorsCSSToFont_link') .'{
		color: %1$s;
	}
	/* BORDER COLOR */
	'. easy_color_getClassesOnBd('easyColorSelectorsCSSToBorder_link') .'{
		border-color: %1$s;
	}
	';

	wp_add_inline_style( 'flash-style', sprintf( $css, $link_color, $border_color, $link_color_dark ) );
}
add_action( 'wp_enqueue_scripts', 'easy_color_flash_link_color_css_MINHA', 11 );





